/*
PROGRAM BAM
===========
BY
JOEL S. DAVIS
1310 CONSTITUTION COURT, NE
ALBUQUERQUE, NM  87112
====================================================================

THIS PROGRAM IS A SIMPLE IMPLEMENTATION OF THE BI-DIRECTIONAL CORRELATION
MEMORY ALGORITHM DEVELOPED BY BART KOSKO.  THE SOURCE CODE IS WRITTEN
FOR DESMET C BY CWARE RUNNING UNDER MS-DOS.

IT COMBINES FEATURES FROM THE DUANE DESIENO BAM PROGRAM, WRITTEN IN BASIC,
AND MY OWN ASSOC AND BASSOC PROGRAMS, WRITTEN IN C.

THIS VERSION IS DATED: 7-AUGUST-1987

COPYRIGHT (C) 1987, JOEL S. DAVIS.  AFTER BYTE PUBLICATION, APPROVED FOR 
NON-COMMERCIAL USE ONLY
*/

#include <\cware\stdio.h>
#include <\cware\math.h>
#include <struct.h>
int a[DIMEN1],b[DIMEN2],x[DIMEN1],y[DIMEN2],xty[DIMEN1][DIMEN2];
int newvec1[DIMEN1],newvec2[DIMEN2];

main(argc,argv)
int argc;
char **argv;
{
int i,j,k,l,m,n,d2;
int op;
int axn,ayn,bxn,byn,n_asyn,pct_noise,an,bn;

/*  INITIALIZE DIMENSIONS   */
    clearbam();
    initial(&axn,&ayn,&bxn,&byn,&an,&bn,&n_asyn,&pct_noise);

/*  INTRODUCTION  */
    intro();

/*  PRESENT MAIN MENU   */
    for(;;){
        op = mainmenu();

        if(op==1){
/*          NEW PROGRAM PARAMETERS     */
            new_parm(&axn,&ayn,&bxn,&byn,&an,&bn,&n_asyn,&pct_noise);

        }else if(op==2){
/*          CLEAR VECTORS AND BAM      */
            clearbam();

        }else if(op==3){
/*          LOAD THE MEMORY MATRIX     */
            get_mtx(&axn,&ayn,&bxn,&byn,&an,&bn);

        }else if(op==4){
/*          SAVE THE MEMORY MATRIX     */
            save_mtx(&axn,&ayn,&bxn,&byn,&an,&bn);

        }else if(op==5){
/*          OPERATE ON MEMORY AND RUN BAM   */
            run_bam(&axn,&ayn,&bxn,&byn,&an,&bn,n_asyn,pct_noise);

        }else if(op==6){
/*          QUIT                            */
            break;
        }
    }
}
